<template>
	<view class="page">
		<view class="qr-card">
			<view class="title">
				邀请好友加入慧研学惠生活
			</view>
			<view class="qrcode-box">
				<u--image width="360rpx" height="360rpx" :src="src">
					<template v-slot:loading>
						<u-loading-icon size="56rpx" color="#0C6FFE"></u-loading-icon>
					</template>
				</u--image>
			</view>
			<view class="save-btn">
				<view style="width: 480rpx">
					<u-button shape="circle" @click="save">保存二维码</u-button>
				</view>
			</view>
		</view>

		<view class="rules">
			<view class="title">
				慧研学惠生活用户邀请活动奖励规则
			</view>

			<view class="rules-content">
				<text>
					一、返利激励机制
					1. 订购奖励：当被推荐的新用户首次订购慧研学惠生活任意档会员，推荐者将从新用户订购期内的月会员费中获得10%的返利激励；
					2. 持续激励：被推荐的新用户持续订购会员，推荐者每月都能享受返利；
					3. 推荐人数无上限：每个慧研学惠生活用户可以推荐的新用户人数没有上限；
					4. 新用户在取消会员订购后，推荐者停止获得返利；
					5. 新用户在取消会员订购后再次订购会员，原推荐者无法继续获得返利；
					二、返利发放条件与时间
					1. 新用户定义：被邀请者须是邀请前未注册、登录过慧研学惠生活平台的用户。
					2. 确认订购：新用户被邀请后的48小时内订购成功，且在5天内无退订行为，系统将自动确认发放返利资格。
					3. 发放时间：当月返利将在次月发放至慧研学惠生活个人账号。
					5. 提现时间：每月25日，推荐者可进行上月返利的提现操作。
					*最终解释权归本平台所有。
				</text>
			</view>

		</view>

	</view>
</template>

<script>
import { BASE_URL } from '@/utils/config.js'
export default {
	data() {
		return {
			src: '',
			userInfo: {}
		}
	},
	methods: {
		save() {
			// uni.getImageInfo({
			// 	src:this.src,
			// 	success: function (image) {
			// 		uni.saveImageToPhotosAlbum({
			// 			filePath:image.path
			// 		})
			// 	}
			// })

			uni.showLoading({
				title: '正在保存图片...'
			});
			//获取用户的当前设置。获取相册权限
			uni.getSetting({
				success: (res) => {
					//如果没有相册权限
					if (!res.authSetting["scope.writePhotosAlbum"]) {
						//向用户发起授权请求
						uni.authorize({
							scope: "scope.writePhotosAlbum",
							success: () => {




								//授权成功保存图片到系统相册
								// uni.saveImageToPhotosAlbum({
								// 	//图片路径，不支持网络图片路径
								// 	filePath: url,
								// 	success: (res) => {
								// 		uni.hideLoading();
								// 		return uni.showToast({
								// 			title: "保存成功！",
								// 		});
								// 	},
								// 	fail: (res) => {
								// 		console.log(res.errMsg);
								// 		return uni.showToast({
								// 			title: res.errMsg,
								// 		});
								// 	},
								// 	complete: (res) => { uni.hideLoading(); },
								// });

								console.log(this.src.slice(22))
								console.log(this.src)
								console.log(wx.env.USER_DATA_PATH + '/pic' + number + '.png')

								const number = Math.random()
								wx.getFileSystemManager().writeFile({
									filePath: wx.env.USER_DATA_PATH + '/pic' + number + '.png',
									data: this.src.slice(22),
									encoding: 'base64',
									success: res => {
										wx.saveImageToPhotosAlbum({
											filePath: wx.env.USER_DATA_PATH + '/pic' + number + '.png',
											success: function (res) {
												wx.showToast({ title: '保存成功', })
											},
											fail: function (err) {
												console.log(err)
											}
										})
										console.log(res)
									}, fail: err => {
										console.log(err)
									}
								})



							},
							//授权失败
							fail: () => {
								uni.hideLoading();
								uni.showModal({
									title: "您已拒绝获取相册权限",
									content: "是否进入权限管理，调整授权？",
									success: (res) => {
										if (res.confirm) {
											//调起客户端小程序设置界面，返回用户设置的操作结果。（重新让用户授权）
											uni.openSetting({
												success: (res) => {
													console.log(res.authSetting);
												},
											});
										} else if (res.cancel) {
											return uni.showToast({
												title: "已取消！",
											});
										}
									},
								});
							},
						});
					} else {




						//如果已有相册权限，直接保存图片到系统相册
						// uni.saveImageToPhotosAlbum({
						// 	filePath: url,
						// 	success: (res) => {
						// 		uni.hideLoading();
						// 		return uni.showToast({
						// 			title: "保存成功！",
						// 		});
						// 	},
						// 	fail: (res) => {
						// 		uni.hideLoading();
						// 		console.log(res.errMsg);
						// 		return uni.showToast({
						// 			title: res.errMsg,
						// 		});
						// 	},
						// 	//无论成功失败都走的回调
						// 	complete: (res) => { uni.hideLoading(); },
						// });


						const number = Math.random()
						wx.getFileSystemManager().writeFile({
							filePath: wx.env.USER_DATA_PATH + '/pic' + number + '.png',
							data: this.src.slice(22),
							encoding: 'base64',
							success: res => {
								wx.saveImageToPhotosAlbum({
									filePath: wx.env.USER_DATA_PATH + '/pic' + number + '.png',
									success: function (res) {
										wx.showToast({ title: '保存成功', })
									},
									fail: function (err) {
										console.log(err)
									}
								})
								console.log(res)
							}, fail: err => {
								console.log(err)
							}
						})


					}
				},
				fail: (res) => { },
			});
		},
	},
	created() {
		this.userInfo = JSON.parse(uni.getStorageSync('userInfo'))
		uni.request({
			url: BASE_URL + '/zswl-cloud-bdb/promotion/qrcode',
			method: "post",
			data: {
				"scene": JSON.parse(uni.getStorageSync('userInfo')).userId,
			},
			responseType: 'arraybuffer'
		}).then(res => {
			this.src = 'data:image/png;base64,' + uni.arrayBufferToBase64(res.data)
		})
	}
}
</script>
<style lang="scss" scoped>
.page {
	background: #F9F9F9;
	min-height: 100vh;
	padding: 24rpx 20rpx;

	.qr-card {
		padding: 42rpx;
		display: flex;
		flex-direction: column;
		justify-items: center;
		justify-content: center;
		background: #FFFFFF;
		border-radius: 16rpx;

		.title {
			font-size: 36rpx;
			color: #222222;
			font-weight: Bold;
			margin-bottom: 36rpx;
			text-align: center;
		}

		.qrcode-box {
			display: flex;
			justify-content: center;
			margin-bottom: 78rpx;
		}

		.save-btn {
			display: flex;
			justify-content: center;
			margin-bottom: 16rpx;
		}
	}

	.rules {
		color: #222222;
		font-size: 36rpx;
		font-weight: Bold;
		margin-top: 30rpx;

		.rules-content {
			color: #CCCCCC;
			font-size: 28rpx;
			margin-top: 16rpx;
			font-weight: 400;
		}
	}
}
</style>